#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

#include "won.h"
#include "wonkrnl.h"

void ircConnectNetwork(WON_MODULE_CTX *modctx,WONKRNL_NETWORK *network)
{
	LINKED_LIST_ITEM *serverItem;
	int x = 0, y = 0;

	serverItem = listGetFirstItem(&network->servers);

	if (network->servers.items)
		x = rand()%network->servers.items;

	while (serverItem && serverItem->value)
	{
		char server[256];

		server[255] = 0;
		snprintf(server,255,"%hi.%hi.%hi.%hi",PRINT_IP(((WONKRNL_SERVER *)serverItem->value)->addr));

		if (y == x)
		{
			wonIrcCreateConnection(modctx->wonctx,network->vhost,server,((WONKRNL_SERVER *)serverItem->value)->port);
			break;
		}

		serverItem = listGetNextItem(serverItem);

		y++;
	}
}

void ircLinkUp(WON_MODULE_CTX *modctx,WON_IRC_CONNECTION *conn)
{
	WONKRNL_DCC_EXTENSION *dccExtension;
	WON_DCC_CONNECTION *dcc;
	LINKED_LIST_ITEM *item, *serverItem;
	WONKRNL_NETWORK *network = NULL;
	WONKRNL_SERVER *server;
	char *nickname;
	int x = 0;

	conn->ircExtension = NULL;

	wonLog(modctx->wonctx,modctx,"Link up!");

	for (item = listGetFirstItem(&WONKRNL_EXT(modctx->moduleExtension)->networks);
			item && item->value;
			item = listGetNextItem(item))
	{
		network = (WONKRNL_NETWORK *)item->value;

		for (serverItem = listGetFirstItem(&network->servers);
				serverItem && serverItem->value;
				serverItem = listGetNextItem(serverItem))
		{
			server = (WONKRNL_SERVER *)serverItem->value;

			if ((server->addr == conn->addr) &&
				(server->port == conn->port))
			{
				conn->ircExtension = network;
				break;
			}
		}

		if (conn->ircExtension)
			break;
	}
	
	while (wonDccEnum(modctx->wonctx,x++,&dcc) != WON_STATUS_FAILURE)
	{
		dccExtension = (WONKRNL_DCC_EXTENSION *)dcc->dccExtension;

		if ((dccExtension) 
			&& (dccExtension->network == network)
			&& (network))
		{
			wonDccSend(modctx->wonctx,dcc,"I've reconnected to \002%s\002.\n",network->name);
			dccExtension->irc = conn;
		}
	}

	if (!network)
	{
		wonLog(modctx->wonctx,modctx,"failed to associate irc connection with a network.");
		nickname = "w0nt0n";
	}
	else
		nickname = network->nickname;

	wonIrcSend(modctx->wonctx,conn,"NICK :%s\n",nickname);
	wonIrcSend(modctx->wonctx,conn,"USER fuck you please die\n");
	
	strncpy(conn->nickname,nickname,WON_MAX_NICKNAME_SIZE);
}

void ircLinkDown(WON_MODULE_CTX *modctx,WON_IRC_CONNECTION *conn)
{
	WONKRNL_DCC_EXTENSION *dccExtension;
	WON_DCC_CONNECTION *dcc;
	WONKRNL_NETWORK *network;
	int x = 0;

	network = (WONKRNL_NETWORK *)conn->ircExtension;

	while (wonDccEnum(modctx->wonctx,x++,&dcc) != WON_STATUS_FAILURE)
	{
		dccExtension = (WONKRNL_DCC_EXTENSION *)dcc->dccExtension;

		if (dccExtension && dccExtension->irc == conn)
		{
			wonDccSend(modctx->wonctx,dcc,
						"I've been disconnected from \002%s\002.\n",(network)?network->name:"Unknown");
			dccExtension->irc = NULL;
		}
	}

	/* Now we reconnect... */

	if (network)
		ircConnectNetwork(modctx,network);
}

uint32 ircConnected(WON_IRC_PACKET *wip)
{
	WONKRNL_NETWORK *network;
	WONKRNL_CHANNEL *channel;
	LINKED_LIST_ITEM *item;

	network = (WONKRNL_NETWORK *)wip->irc->ircExtension;

	if (!network)
		return WON_STATUS_FAILURE;

	wonLog(wip->ctx,wip->modctx,"Connected to irc (network = %s)",network->name);

	for (item = listGetFirstItem(&network->channels);
			item && item->value;
			item = listGetNextItem(item))
	{
		channel = (WONKRNL_CHANNEL *)item->value;

		if (channel->key)
			wonIrcSend(wip->ctx,wip->irc,"JOIN %s :%s\n",channel->channel,channel->key);
		else
			wonIrcSend(wip->ctx,wip->irc,"JOIN %s\n",channel->channel);
	}

	return WON_STATUS_SUCCESS;
}

uint32 ircNamesList(WON_IRC_PACKET *wip)	/* 353		1 */
{
	WONKRNL_CHANNEL *channel;

	if (wip->buffer->words < 6)
		return WON_STATUS_FAILURE;

	channel = configLookupChannel(wip->irc,wip->buffer->str[4]);

	if (!channel)
		return WON_STATUS_FAILURE;

	if (!strcmp(wip->buffer->str[5]+2,wip->irc->nickname))
		BIT_SET(channel->state,WONKRNL_STATE_CHANNEL_OP);

	return WON_STATUS_SUCCESS;
}

uint32 ircEndMotd(WON_IRC_PACKET *wip)		/* 376		1 */
{
	wonIrcConnectionSetState(wip->irc,WON_IRC_STATE_ONLINE);

	return WON_STATUS_SUCCESS;
}

uint32 ircNick(WON_IRC_PACKET *wip)		/* 433		1 */
{
	if (!wonIrcConnectionIsState(wip->irc,WON_IRC_STATE_ONLINE))
	{
		char newNickName[WON_MAX_NICKNAME_SIZE];

		newNickName[WON_MAX_NICKNAME_SIZE-1] = 0;
		wip->irc->nickname[6] = 0;
		snprintf(newNickName,WON_MAX_NICKNAME_SIZE-1,"%s%i",wip->irc->nickname,rand()%100);
		wonIrcSend(wip->ctx,wip->irc,"NICK :%s\n",newNickName);

		fprintf(stdout,"setting nickname to %s\n",newNickName);

		wonIrcConnectionSetNickName(wip->ctx,wip->irc,newNickName);
	}

	return WON_STATUS_SUCCESS;
}

uint32 ircInviteOnly(WON_IRC_PACKET *wip)	/* 473		1 */
{
	return WON_STATUS_SUCCESS;
}

uint32 ircRegister(WON_IRC_PACKET *wip)		/* 451 		1 */
{
	ircLinkUp(wip->modctx,wip->irc);

	return WON_STATUS_SUCCESS;
}

uint32 ircPrivmsg(WON_IRC_PACKET *wip)		/* PRIVMSG	1 */
{
	WONKRNL_NETWORK *network;
	char *endOfCtcp;

	if (wip->buffer->words < 4)
		return WON_STATUS_FAILURE;

	network = (WONKRNL_NETWORK *)wip->irc->ircExtension;

	/* CTCP's */
	if (wip->buffer->str[3][1] == 1)
	{
		if ((endOfCtcp = strchr(wip->buffer->str[3]+2,1)))
			*endOfCtcp = 0;

		if (!strcmp(wip->buffer->str[3]+2,"VERSION"))
			wonIrcSend(wip->ctx,
					wip->irc,
					"NOTICE %s :\001VERSION %s\001\n",
					wip->fromNick,
					network->versionReply);
		else if (!strcmp(wip->buffer->str[3]+2,"DCC"))
			dccEstablishConnection(wip);
	}

	return WON_STATUS_SUCCESS;
}

uint32 ircMode(WON_IRC_PACKET *wip)		/* MODE		1 */
{
	WONKRNL_CHANNEL *channel;
	int x = 0, inPlus = 0, currOffset = 4;

#define modeModes wip->buffer->str[3]
#define modeChannel wip->buffer->str[2]

	if (wip->buffer->words < 4)
		return WON_STATUS_FAILURE;

	channel = configLookupChannel(wip->irc,modeChannel);

	if (!channel)
		return WON_STATUS_FAILURE;

	for (x = 0; x < strlen(modeModes); x++)
	{
		if (modeModes[x] == '+')
			inPlus = 1;
		else if (modeModes[x] == '-')
			inPlus = 0;
		else if (wip->buffer->str[currOffset])
		{
			if (!strcmp(wip->buffer->str[currOffset],wip->irc->nickname))
			{
				if (inPlus)
					BIT_SET(channel->state,WONKRNL_STATE_CHANNEL_OP);
				else
					BIT_REMOVE(channel->state,WONKRNL_STATE_CHANNEL_OP);
			}

			currOffset++;
		}
	}

	return WON_STATUS_SUCCESS;
}

uint32 ircJoin(WON_IRC_PACKET *wip)		/* JOIN		1 */
{
	WONKRNL_CHANNEL *channel;

#define joinMask wip->buffer->str[0]

	if (wip->buffer->words < 3)
		return WON_STATUS_FAILURE;

	channel = configLookupChannel(wip->irc,wip->buffer->str[2]+1);

	if (!channel)
		return WON_STATUS_FAILURE;

	if (!strcmp(wip->fromNick,wip->irc->nickname))
		BIT_SET(channel->state,WONKRNL_STATE_CHANNEL_IN);
	else if IS_SET(channel->state,WONKRNL_STATE_CHANNEL_OP)
	{
		LINKED_LIST_ITEM *item;
		WONKRNL_BAN *ban;
		WONKRNL_USER *user = configLookupUserByMask(wip->irc,wip->buffer->str[0]+1);
		WONKRNL_USER_CHANNEL *userChannel;

		for (item = listGetFirstItem(&channel->bans);
			item && item->value;
			item = listGetNextItem(item))
		{
			ban = (WONKRNL_BAN *)item->value;

			if (wonWildcardMatch(ban->mask,joinMask+1))
			{
				wonIrcSend(wip->ctx,wip->irc,"MODE %s -o+b %s %s\n",channel->channel,wip->fromNick,ban->mask);
				wonIrcSend(wip->ctx,wip->irc,"KICK %s %s :%s\n",channel->channel,wip->fromNick,ban->reason);

				break;
			}
		}

		if (user)
		{
			userChannel = listGetValueStringId(&user->channels,channel->channel);

			if (((userChannel) && (IS_SET(userChannel->access,WONKRNL_ACCESS_AUTO_OPS)))
					|| (IS_SET(user->gaccess,WONKRNL_ACCESS_AUTO_OPS)))
				wonIrcSend(wip->ctx,wip->irc,"MODE %s +o %s\n",channel->channel,wip->fromNick);
		}
	}

	return WON_STATUS_SUCCESS;
}

uint32 ircPart(WON_IRC_PACKET *wip)		/* PART		1 */
{
	if (wip->buffer->words < 3)
		return WON_STATUS_FAILURE;

	if (!strcmp(wip->fromNick,wip->irc->nickname))
	{
		WONKRNL_CHANNEL *channel = configLookupChannel(wip->irc,wip->buffer->str[2]+1);

		if (channel)
			BIT_REMOVE(channel->state,WONKRNL_STATE_CHANNEL_IN);
	}

	return WON_STATUS_SUCCESS;
}

uint32 ircNickChange(WON_IRC_PACKET *wip)	/* NICK		1 */
{
	return WON_STATUS_SUCCESS;
}

uint32 ircKick(WON_IRC_PACKET *wip)		/* KICK		1 */
{
	WONKRNL_CHANNEL *channel;
#define kickedNick wip->buffer->str[3]
#define kickedChannel wip->buffer->str[2]

	if (wip->buffer->words < 4)
		return WON_STATUS_FAILURE;

	if (!strcmp(kickedNick,wip->irc->nickname))
	{
		channel = configLookupChannel(wip->irc,kickedChannel);

		if (!channel)
			return WON_STATUS_FAILURE;

		BIT_REMOVE(channel->state,WONKRNL_STATE_CHANNEL_IN);
		BIT_REMOVE(channel->state,WONKRNL_STATE_CHANNEL_OP);

		if (channel->key)
			wonIrcSend(wip->ctx,wip->irc,"JOIN %s :%s\n",channel->channel,channel->key);
		else
			wonIrcSend(wip->ctx,wip->irc,"JOIN %s\n",channel->channel);
	}

	return WON_STATUS_SUCCESS;
}

uint32 ircInvite(WON_IRC_PACKET *wip)		/* INVITE	1 */
{
	WONKRNL_CHANNEL *channel;
#define inviteChannel wip->buffer->str[3]

	if (wip->buffer->words < 4)
		return WON_STATUS_FAILURE;

	channel = configLookupChannel(wip->irc,inviteChannel+1);

	if (!channel)
		return WON_STATUS_FAILURE;

	if (channel->key)
		wonIrcSend(wip->ctx,wip->irc,"JOIN %s :%s\n",channel->channel,channel->key);
	else
		wonIrcSend(wip->ctx,wip->irc,"JOIN %s\n",channel->channel);

	return WON_STATUS_SUCCESS;
}

uint32 ircPing(WON_IRC_PACKET *wip)		/* PING		0 */
{
	if (wip->buffer->str[1])
		wonIrcSend(wip->ctx,wip->irc,"PONG %s\nPONG PONG\n",wip->buffer->str[1]);
	else
		wonIrcSend(wip->ctx,wip->irc,"PONG 127.0.0.1\nPONG PONG\n");

	return WON_STATUS_SUCCESS;
}


