#include <stdlib.h>
#include <stdio.h>

#include "won.h"
#include "wonkrnl.h"

void wonLoad(WON_MODULE_CTX *modctx)
{
	wonLog(modctx->wonctx,modctx,"wonton kernel loading.");

	modctx->moduleExtension 	= wonMemoryAllocate(sizeof(WONKRNL_MODULE_EXTENSION),1);

	/* Configuration handlers 	*/

	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "start", configStart);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "end", configEnd);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "server", configServer);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "nickname", configNickname);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "vhost", configVhost);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "version_reply", configVersionReply);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "dcc_user_prompt", configDccUserPrompt);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "dcc_pass_prompt", configDccPassPrompt);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "motd_file", configMotdFile); 
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "begin_channel", configBeginChannel);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "end_channel", configEndChannel);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "channel_key", configChannelKey);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "add_ban", configAddBan);

	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "begin_user", configBeginUser);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "end_user", configEndUser);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "password", configPassword);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "global_access", configGlobalAccess);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "allow_host", configAllowHost);
	wonConfigRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "channel_access", configChannelAccess);

	/* IRC Handlers 		*/
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "001", 1, ircConnected);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "353", 1, ircNamesList);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "376", 1, ircEndMotd);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "433", 1, ircNick);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "473", 1, ircInviteOnly);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "451", 1, ircRegister);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "PRIVMSG", 1, ircPrivmsg);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "MODE", 1, ircMode);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "JOIN", 1, ircJoin);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "PART", 1, ircPart);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "NICK", 1, ircNickChange);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "KICK", 1, ircKick);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "INVITE", 1, ircInvite);
	wonIrcRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, "PING", 0, ircPing);

	/* DCC Handlers			*/

	wonLowlevelRecvRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, dccLowlevel);

	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".adduser", 0, dccAddUser);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".deluser", 0, dccDelUser);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".userinfo", 0, dccUserInfo);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".uattr", 0, dccUattr);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".cattr", 0, dccCattr);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".addhost", 0, dccAddHost);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".delhost", 0, dccDelHost);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".passwd", 0, dccPasswd);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".boot", 0, dccBoot);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".addchan", 0, dccAddChan);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".delchan", 0, dccDelChan);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".chaninfo", 0, dccChanInfo);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".console", 0, dccConsole);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".say", 0, dccSay);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".op", 0, dccOp);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".invite", 0, dccInvite);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".kick", 0, dccKick);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".addban", 0, dccAddBan);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".delban", 0, dccDelBan);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".banlist", 0, dccBanList);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".loadmodule", 0, dccLoadModule);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".unloadmodule", 0, dccUnloadModule);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".reloadmodule", 0, dccReloadModule);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".listmodules", 0, dccListModules);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".msg", 0, dccMsg);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".help", 0, dccHelp);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".version", 0, dccVersion);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".quit", 0, dccQuit);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".echo", 0, dccEcho);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".save", 0, dccSave);
	wonDccRegisterLayeredHandler(modctx->wonctx, modctx, WON_LAYER_FIRST, ".who", 0, dccWho);

	wonLog(modctx->wonctx,modctx,"wonton kernel loaded.");
}

void wonLoadComplete(WON_MODULE_CTX *modctx)
{
	WONKRNL_MODULE_EXTENSION *krnl = WONKRNL_EXT(modctx->moduleExtension);
	LINKED_LIST_ITEM *item;
	WONKRNL_NETWORK *network;

	item = listGetFirstItem(&krnl->networks);

	while (item)
	{
		network = (WONKRNL_NETWORK *)item->value;

		if (network)
			ircConnectNetwork(modctx,network);

		item = listGetNextItem(item);
	}
}

void wonIoctl(WON_MODULE_CTX *modctx, uint32 ioctl, WON_IC *wic)
{
	switch (ioctl)
	{
		case WON_IOCTL_LOAD_COMPLETE:
			wonLoadComplete(modctx);
			break;
		case WON_IOCTL_IRC_LINK_UP:
			ircLinkUp(modctx,wic->inBuffer);
			break;
		case WON_IOCTL_IRC_LINK_DOWN:
			ircLinkDown(modctx,wic->inBuffer);
			break;
		case WON_IOCTL_DCC_LINK_UP:
			dccLinkUp(modctx,wic->inBuffer);
			break;
		case WON_IOCTL_DCC_LINK_DOWN:
			dccLinkDown(modctx,wic->inBuffer);
			break;
		case WON_IOCTL_CONFIG_SAVE:
			if (wic->inLen == 4)
				configSave(modctx,(FILE *)wic->inBuffer);
			break;
	}
}

void wonUnload(WON_MODULE_CTX *modctx)
{
	wonLog(modctx->wonctx,modctx,"wonton kernel unloading.");

	free(modctx->moduleExtension);

	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "start", configStart);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "end", configEnd);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "server", configServer);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "nickname", configNickname);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "vhost", configVhost);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "version_reply", configVersionReply);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "dcc_user_prompt", configDccUserPrompt);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "dcc_pass_prompt", configDccPassPrompt);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "motd_file", configMotdFile); 
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "begin_channel", configBeginChannel);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "end_channel", configEndChannel);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "channel_key", configChannelKey);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "add_ban", configAddBan);

	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "begin_user", configBeginUser);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "end_user", configEndUser);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "password", configPassword);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "global_access", configGlobalAccess);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "allow_host", configAllowHost);
	wonConfigDeregisterLayeredHandler(modctx->wonctx, modctx, "channel_access", configChannelAccess);


	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "001", 1, ircConnected);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "353", 1, ircNamesList);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "376", 1, ircEndMotd);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "433", 1, ircNick);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "473", 1, ircInviteOnly);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "451", 1, ircRegister);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "PRIVMSG", 1, ircPrivmsg);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "MODE", 1, ircMode);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "JOIN", 1, ircJoin);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "PART", 1, ircPart);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "NICK", 1, ircNickChange);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "KICK", 1, ircKick);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "INVITE", 1, ircInvite);
	wonIrcDeregisterLayeredHandler(modctx->wonctx, modctx, "PING", 0, ircPing);
	
	/* DCC */

	wonLowlevelRecvDeregisterLayeredHandler(modctx->wonctx, dccLowlevel);
	
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".adduser", 0, dccAddUser);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".deluser", 0, dccDelUser);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".userinfo", 0, dccUserInfo);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".uattr", 0, dccUattr);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".cattr", 0, dccCattr);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".addhost", 0, dccAddHost);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".delhost", 0, dccDelHost);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".passwd", 0, dccPasswd);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".boot", 0, dccBoot);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".addchan", 0, dccAddChan);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".delchan", 0, dccDelChan);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".chaninfo", 0, dccChanInfo);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".console", 0, dccConsole);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".say", 0, dccSay);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".op", 0, dccOp);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".invite", 0, dccInvite);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".kick", 0, dccKick);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".addban", 0, dccAddBan);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".delban", 0, dccDelBan);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".banlist", 0, dccBanList);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".loadmodule", 0, dccLoadModule);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".unloadmodule", 0, dccUnloadModule);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".reloadmodule", 0, dccReloadModule);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".listmodules", 0, dccListModules);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".msg", 0, dccMsg);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".help", 0, dccHelp);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".version", 0, dccVersion);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".quit", 0, dccQuit);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".echo", 0, dccEcho);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".save", 0, dccSave);
	wonDccDeregisterLayeredHandler(modctx->wonctx, modctx, ".who", 0, dccWho);

	wonLog(modctx->wonctx,modctx,"wonton kernel unloaded.");
}
